; Edit partition for WINED
; this shows the existing partitions
; v. 1.00	1994 Jun 29 15:07:36
;  W. Lenerz 1994 - 2018

; type	 of partition
; start "     "
; length	"      "


	section edpart

	xdef	editpart

	xref	men_array	; array with menu choices
	xref	men_title	; title for menu
	xref	do_list 	; does list extension
	xref	colw		; colourway byte
	xref	readsec2		; set position according to d1
	xref	do_list 	; do list menu exten (lib_menu_list)
	xref	partchoice	; menu name (wined english)
	xref	warning 	; (wined_filerr)
	xref	nopartt

	include dev1_asm_wined_includes

editpart
	move.l	#0,d1
	bsr	readsec2		; read sector 0
	cmp.l	#'QLWA',(a1)	; is this a ql partition?
	beq	no_part 	; yes, so there is no partition info
	move.l	$1c6(a1),d1
	andi.l	#$ffffff,d1
	cmp.l	#'GEM',d1
	beq.s	is_gem
	cmp.l	#'BGM',d1
	beq.s	is_gem
	cmp.l	#'QWA',d1
	bne	no_part
is_gem	lea	numbersp(a4),a2
	move.l	#$e,(a2)+
	move.l	#$20000,(a2)+
	move.w	#10,(a2)+
	move.w	#8,(a2)+
	move.w	#1,(a2)+
	moveq	#-1,d2		 ; d2 is counter for
	lea	partinfo(a4),a3
loop1	moveq	#2,d0
	lea	$1c6(a1),a1
loop2	move.l	(a1)+,d1
	andi.l	#$ffffff,d1
	move.l	(a1)+,d3		; start
	beq	endparts
	move.l	d3,(a3)+
	lsl.l	#8,d1
	move.b	#' ',d1
	cmp.l	#'QWA ',d1
	bne.s	noql
	move.w	#8,(a2)
	move.l	d1,2(a2)
	move.l	#'*QL*',6(a2)
	bra.s	doloop2
noql	move.w	#3,(a2)
	move.l	d1,2(a2)
doloop2 addq.l	#4,a1
	lea	10(a2),a2
	addq.w	#1,d2
	dbf	d0,loop2
	move.l	(a1)+,d1
	andi.l	#$ffffff,d1
	cmp.l	#'XGM',d1	; is it an extended table?
	bne.s	no_xtd
	move.l	(a1)+,d1
	move.l	d2,-(a7)
	bsr	readsec2
	move.l	(a7)+,d2
	bra.s	loop1
no_xtd	move.l	(a1)+,d3
	beq.s	endparts
	move.l	d3,(a3)+
	lsl.l	#8,d1
	move.b	#' ',d1
	cmp.l	#'QWA ',d1
	bne.s	noql2
	move.w	#8,(a2)
	move.l	d1,2(a2)
	move.l	#'*QL*',6(a2)
	bra.s	dollop2
noql2	move.w	#3,(a2)
	move.l	d1,2(a2)
dollop2 addq.w	#1,d2
endparts
	lea	numbersp(a4),a1
	move.w	d2,6(a1)
	moveq	#0,d1
	move.l	#winpos,d2
	lea	colw,a2
	moveq	#0,d3
	move.b	(a2),d3
	moveq	#4,d4
	lea	partchoice,a0
	sub.l	a2,a2
	jsr	do_list
	move.w	(a1),d1
	ble.s	ep_out
	lsl.w	#2,d1
	lea	partinfo(a4),a1
	move.l	(a1,d1.w),sector(a4)
ep_out	move.l	8(a4),a0
	rts

no_part lea	nopartt,a1
	moveq	#-7,d0
	jsr	warning
	bra.s	ep_out


	end
