; CONFIG file for WINED
;
; v. 1.09	2003 May 08 13:27:33
;  W. Lenerz 1994 - 2018

	section config
	include dev1_asm_wined_includes

	xdef	colw
	xdef	btncol
	xdef	windrive
	xdef	flop
	xdef	wtype
	xdef	dvnbr
	xdef	windrive
	xdef	flop
	xdef	deftrak
	xdef	defside
	xdef	nosel
	xdef	flptype
	xdef	doselect
	xdef	wintype
	xdef	defmcol

	xref	noseldescr
	xref	yesnoattr
	xref	colattr 	; language texts
	xref	coldescr
	xref	btndes
;	 xref	 appdescr
	xref.l	version
	xref	ddrivedes
	xref	driveattr
	xref	floppyname
	xref	numberdes
	xref	winname
	xref	flopsidattr
	xref	flopsidescr
	xref	trackattr
	xref	trackdescr
	xref	typedescr
	xref	doseldescr
	xref	wintdesc
	xref	defcoldesc

colw	dc.b	4
btncol	dc.b	4
wtype	dc.b	1			; type of default drive: 1 = win, 3 = flop
dvnbr	dc.b	1			;  default drive nbr (always 1 for now)
defside dc.b	1			; double sided disks is default
deftrak dc.b	79			; 80 tracks is default
nosel	dc.b	0			; don't go into default drive
;newmove dc.b	 1
windr	dc.w	4
windrive dc.w	3,'WIN' 		; name for win
flp	dc.w	4
flop	dc.w	3,'FLP' 		; name for flp
flptype dc.b	0			; floppy type: 0= dd *, 1= hd, 2= ed
doselect dc.b	1			; select floppy type after drive? - preset 'yes'
wintype dc.b	0			; preset win drive type
					; 0 = miracle *
					; 1 = qubide
defmcol dc.b	$0			; use menu default colours (yes)

; Qjump configuration format
	dc.w	'<<QCFC>>'
	dc.w	'<<QCFX>>'
	dc.w	'02'
	dc.w	qc1-*-2
	dc.b	'Colours / Farben'
qc1
	dc.w	4
	dc.l	version

; get default colours from menu extensions?

defcol	dc.l	'WEDK'
	dc.b	4		; type of item
	dc.b	'M'		; character keystroke
	dc.w	defmcol-*	; pointer to item
	dc.l	0		; NO pre_ and post-processing
	dc.w	defcoldesc-*	; description
	dc.w	yesnoattr-*	 ; attributes

; main colour?
twoit1	dc.l	'_COL'
	dc.b	4		; type of item
	dc.b	'C'		; character keystroke
	dc.w	colw-*		; pointer to item
	dc.l	0		; NO pre_ and post-processing
	dc.w	coldescr-*	; description
	dc.w	colattr-*	; attributes

;	 dc.l	 '_COS'
;	 dc.b	 4		 ; type of item
;	 dc.b	 'A'		 ; character keystroke
;	 dc.w	 colwa-*	  ; pointer to item
;	 dc.l	 0		 ; NO pre_ and post-processing
;	 dc.w	 appdescr-*	 ; description
;	 dc.w	 colattr-*	 ; attributes

; button colour?
	dc.l	'_COB'
	dc.b	4		; type of item
	dc.b	'B'		; character keystroke
	dc.w	btncol-*		; pointer to item
	dc.l	0		; NO pre_ and post-processing
	dc.w	btndes-*		; description
	dc.w	colattr-*	; attributes

	dc.w	-1



	dc.w	'<<QCFX>>'
	dc.w	'02'
	dc.w	qc2-*-2
	dc.b	'Defaults'
qc2
	dc.w	4
	dc.l	version
; default drive: floppy,harddisk
	dc.l	'WEDA'
	dc.b	4		; type of item
	dc.b	'D'		; character keystroke
	dc.w	wtype-* 	; pointer to item
	dc.l	0		; NO pre_ and post-processing
	dc.w	ddrivedes-*	; description
	dc.w	driveattr-*	; attributes
; default drive nbr
	dc.l	'WEDB'
	dc.b	8		; type of item
	dc.b	'N'		; character keystroke
	dc.w	dvnbr-* 	; pointer to item
	dc.l	0		; NO pre_ and post-processing
	dc.w	numberdes-*	; description
	dc.w	battr-* 	; attributes
; floppy driver name
	dc.l	'WEDC'
	dc.b	0		; type of item
	dc.b	'F'		; character keystroke
	dc.w	flp-*		; pointer to item
	dc.l	0		; NO pre_ and post-processing
	dc.w	floppyname-*	 ; description
	dc.w	strattr-*	  ; attributes
; win driver name
	dc.l	'WEDD'
	dc.b	0		; type of item
	dc.b	'W'		; character keystroke
	dc.w	windr-* 	  ; pointer to item
	dc.l	0		; NO pre_ and post-processing
	dc.w	winname-*	  ; description
	dc.w	strattr-*	  ; attributes
; go strait to default drive?
	dc.l	'WEDE'
	dc.b	4		; type of item
	dc.b	'N'		; character keystroke
	dc.w	nosel-* 	; pointer to item
	dc.l	0		; NO pre_ and post-processing
	dc.w	noseldescr-*	  ; description
	dc.w	yesnoattr-*	  ; attributes


; win interface (qxl rebel)
	dc.l	'WEDJ'
	dc.b	4		; type of item
	dc.b	'Y'		; character keystroke
	dc.w	wintype-*	; pointer to item
	dc.l	0		; NO pre_ and post-processing
	dc.w	wintdesc-*	; description
	dc.w	winattr-*	; attributes

	dc.w	-1


	dc.w	'<<QCFX>>'
	dc.w	'02'
	dc.w	qc3-*-2
	dc.b	'Floppy Disk'
qc3
	dc.w	4
	dc.l	version
; single, double sided floppies
	dc.l	'WEDF'
	dc.b	4		; type of item
	dc.b	'S'		; character keystroke
	dc.w	defside-*	; pointer to item
	dc.l	0		; NO pre_ and post-processing
	dc.w	flopsidescr-*	   ; description
	dc.w	flopsidattr-*	    ; attributes
; nbr of tracks
	dc.l	'WEDG'
	dc.b	4		; type of item
	dc.b	'T'		; character keystroke
	dc.w	deftrak-*	; pointer to item
	dc.l	0		; NO pre_ and post-processing
	dc.w	trackdescr-*	  ; description
	dc.w	trackattr-*	  ; attributes
; floppy type
	dc.l	'WEDH'
	dc.b	4		; type of item
	dc.b	'Y'		; character keystroke
	dc.w	flptype-*	; pointer to item
	dc.l	0		; NO pre_ and post-processing
	dc.w	typedescr-*	 ; description
	dc.w	typeattr-*	 ; attributes
; pull down floppy menu
	dc.l	'WEDI'
	dc.b	4		; type of item
	dc.b	'Y'		; character keystroke
	dc.w	doselect-*	 ; pointer to item
	dc.l	0		; NO pre_ and post-processing
	dc.w	doseldescr-*	  ; description
	dc.w	yesnoattr-*	  ; attributes

	dc.w	-1

battr	dc.b	1,8
strattr dc.w	0

typeattr
	dc.b	0,0
	dc.w	10,'DD (720 K)'
	dc.b	1,0
	dc.w	11,'HD (1440 K)'
	dc.b	2,0
	dc.w	11,'ED (3.2 MB)'
	dc.w	-1
		

winattr dc.b	0,0
	dc.w	33,'QPC / MIRACLE / QXL / ATARI / Q40'
	dc.b	1,0
	dc.w	14,'QUBIDE / REBEL'
	dc.w	-1
	end
; WEDL is last
